/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the LinkedinStaticUserAuthAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &LinkedinStaticUserAuthAllOf{}

// LinkedinStaticUserAuthAllOf struct for LinkedinStaticUserAuthAllOf
type LinkedinStaticUserAuthAllOf struct {
	ClientId     *string `json:"clientId,omitempty"`
	ClientSecret *string `json:"clientSecret,omitempty"`
	RedirectUri  *string `json:"redirectUri,omitempty"`
}

// NewLinkedinStaticUserAuthAllOf instantiates a new LinkedinStaticUserAuthAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewLinkedinStaticUserAuthAllOf() *LinkedinStaticUserAuthAllOf {
	this := LinkedinStaticUserAuthAllOf{}
	return &this
}

// NewLinkedinStaticUserAuthAllOfWithDefaults instantiates a new LinkedinStaticUserAuthAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewLinkedinStaticUserAuthAllOfWithDefaults() *LinkedinStaticUserAuthAllOf {
	this := LinkedinStaticUserAuthAllOf{}
	return &this
}

// GetClientId returns the ClientId field value if set, zero value otherwise.
func (o *LinkedinStaticUserAuthAllOf) GetClientId() string {
	if o == nil || IsNil(o.ClientId) {
		var ret string
		return ret
	}
	return *o.ClientId
}

// GetClientIdOk returns a tuple with the ClientId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *LinkedinStaticUserAuthAllOf) GetClientIdOk() (*string, bool) {
	if o == nil || IsNil(o.ClientId) {
		return nil, false
	}
	return o.ClientId, true
}

// HasClientId returns a boolean if a field has been set.
func (o *LinkedinStaticUserAuthAllOf) HasClientId() bool {
	if o != nil && !IsNil(o.ClientId) {
		return true
	}

	return false
}

// SetClientId gets a reference to the given string and assigns it to the ClientId field.
func (o *LinkedinStaticUserAuthAllOf) SetClientId(v string) {
	o.ClientId = &v
}

// GetClientSecret returns the ClientSecret field value if set, zero value otherwise.
func (o *LinkedinStaticUserAuthAllOf) GetClientSecret() string {
	if o == nil || IsNil(o.ClientSecret) {
		var ret string
		return ret
	}
	return *o.ClientSecret
}

// GetClientSecretOk returns a tuple with the ClientSecret field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *LinkedinStaticUserAuthAllOf) GetClientSecretOk() (*string, bool) {
	if o == nil || IsNil(o.ClientSecret) {
		return nil, false
	}
	return o.ClientSecret, true
}

// HasClientSecret returns a boolean if a field has been set.
func (o *LinkedinStaticUserAuthAllOf) HasClientSecret() bool {
	if o != nil && !IsNil(o.ClientSecret) {
		return true
	}

	return false
}

// SetClientSecret gets a reference to the given string and assigns it to the ClientSecret field.
func (o *LinkedinStaticUserAuthAllOf) SetClientSecret(v string) {
	o.ClientSecret = &v
}

// GetRedirectUri returns the RedirectUri field value if set, zero value otherwise.
func (o *LinkedinStaticUserAuthAllOf) GetRedirectUri() string {
	if o == nil || IsNil(o.RedirectUri) {
		var ret string
		return ret
	}
	return *o.RedirectUri
}

// GetRedirectUriOk returns a tuple with the RedirectUri field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *LinkedinStaticUserAuthAllOf) GetRedirectUriOk() (*string, bool) {
	if o == nil || IsNil(o.RedirectUri) {
		return nil, false
	}
	return o.RedirectUri, true
}

// HasRedirectUri returns a boolean if a field has been set.
func (o *LinkedinStaticUserAuthAllOf) HasRedirectUri() bool {
	if o != nil && !IsNil(o.RedirectUri) {
		return true
	}

	return false
}

// SetRedirectUri gets a reference to the given string and assigns it to the RedirectUri field.
func (o *LinkedinStaticUserAuthAllOf) SetRedirectUri(v string) {
	o.RedirectUri = &v
}

func (o LinkedinStaticUserAuthAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o LinkedinStaticUserAuthAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.ClientId) {
		toSerialize["clientId"] = o.ClientId
	}
	if !IsNil(o.ClientSecret) {
		toSerialize["clientSecret"] = o.ClientSecret
	}
	if !IsNil(o.RedirectUri) {
		toSerialize["redirectUri"] = o.RedirectUri
	}
	return toSerialize, nil
}

type NullableLinkedinStaticUserAuthAllOf struct {
	value *LinkedinStaticUserAuthAllOf
	isSet bool
}

func (v NullableLinkedinStaticUserAuthAllOf) Get() *LinkedinStaticUserAuthAllOf {
	return v.value
}

func (v *NullableLinkedinStaticUserAuthAllOf) Set(val *LinkedinStaticUserAuthAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableLinkedinStaticUserAuthAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableLinkedinStaticUserAuthAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableLinkedinStaticUserAuthAllOf(val *LinkedinStaticUserAuthAllOf) *NullableLinkedinStaticUserAuthAllOf {
	return &NullableLinkedinStaticUserAuthAllOf{value: val, isSet: true}
}

func (v NullableLinkedinStaticUserAuthAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableLinkedinStaticUserAuthAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
